<?php
namespace Teknisa\CNC\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Teknisa\CNC\Services;
use Teknisa\CNC\Utilities;

class Cnc01400CancelamentosAjustes extends \Zeedhi\Framework\Controller\Simple {
    
    protected $cancelAdjustService;
    protected $salesMessage;
    
    public function __construct(Services\Cnc01400CancelamentosAjustes $cancelAdjustService, Utilities\SalesMessageCNC $salesMessage) {
        $this->cancelAdjustService  = $cancelAdjustService;
        $this->salesMessage  = $salesMessage;
    }

    public function getCancelAdjustments(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $resultado = $this->cancelAdjustService->getCancelAdjustments($params);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc01400_CancelamentosAjustesRepo', $resultado));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function changeSituationAdjustments(DTO\Request $request, DTO\Response $response){
        try {
            $params = $request->getDataSet()->getRows();
            $resultado = $this->cancelAdjustService->changeSituationAdjustments($params);
            $message= array($this->salesMessage->getMessage('alterado'));
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc01400_CancelamentosAjustesRepo', $message));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function getErrors(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $resultado = $this->cancelAdjustService->getErrors($params);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc01400_ErrosContabRepo', $resultado));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function deleteErrors(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows();
            $this->cancelAdjustService->deleteErrors($row);
            
            $message= array($this->salesMessage->getMessage('excluido'));
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('Cnc01400_ErrosContabRepo', $message));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

}