<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\CNC\Query;

class Cnc00300ProdutoAdquirenteFactory {
    protected $connection;
    protected $queries;

    public function __construct(EntityManager $entityManager, Query\Query $queries) {
        $this->connection = $entityManager->getConnection();
        $this->queries = $queries;
    }
    
    public function getProdAdq($params){
        $sql = $this->queries::GET_PROD_ADQ;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutosGer($params){
        $sql = $this->queries::GET_PRODUTO_GER;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutos($params){
        $sql = $this->queries::GET_PRODUTOS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutosFiltered($query){
        $sql = $query;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function fetchTipoRece($params){
        $sql = $this->queries::FETCH_TIPO_RECE;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveProduct($params) {
        $sql = $this->queries::SAVE_PRODUCT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveTypeUpdateAdq($params) {
        $sql = $this->queries::SAVE_TYPE_UPDATE_ADQ;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveTypeInsertAdq($params) {
        $sql = $this->queries::SAVE_TYPE_INSERT_ADQ;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getNrSequencialFromTaxaAdqProd($params) {
        $sql = $this->queries::GET_NRSEQUENCIAL_FROM_TAXAA_ADQ_PROD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function checkRowIsNotNull($params) {
        $sql = $this->queries::CHECK_ROW_IS_NOT_NULL;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveEstabelec($params) {
        $sql = $this->queries::SAVE_ESTABELEC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getEstabelecFromTaxaAdqProd($params) {
        $sql = $this->queries::GET_ESTABELEC_FROM_TAXA_ADQ_PROD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getEstabelecFromTaxaAdqProdEdit($params) {
        $sql = $this->queries::GET_ESTABELEC_FROM_TAXA_ADQ_PROD_EDIT;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function isTotalEstabelec($params) {
        $sql = $this->queries::IS_TOTAL_ESTABELEC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveEditEstabelec($params) {
        $sql = $this->queries::SAVE_EDIT_ESTABELEC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveEditEstabelecType2($params) {
        $sql = $this->queries::SAVE_EDIT_ESTABELEC_TYPE_TWO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeEstabelec($params) {
        $sql = $this->queries::REMOVE_ESTABELEC;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeTaxaAdqProd($params) {
        $sql = $this->queries::REMOVE_TAXA_ADQ_PROD;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeProdAdq($params) {
        $sql = $this->queries::REMOVE_PROD_ADQ;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getNrSequencialFromEstabelecToRemove($params) {
        $sql = $this->queries::GET_NRSEQUENCIAL_FROM_ESTABELEC_TO_REMOVE;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getNrSequencialFromEstabelecToRemoveEst($params) {
        $sql = $this->queries::GET_NRSEQUENCIAL_FROM_ESTABELEC_TO_REMOVE_EST;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getNrSequencialToRemove($params) {
        $sql = $this->queries::GET_NRSEQUENCIAL_TO_REMOVE;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getPeriodTaxa($params){
        $sql = $this->queries::GET_PERIOD_TAXA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getPeriodTaxaRow($params){
        $sql = $this->queries::GET_PERIOD_TAXA_ROW;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function alterarPeriodoTaxa($params){
        $sql = $this->queries::ALTERA_PEDIDO_TAXA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function inserirPeriodoTaxa($params){
        $sql = $this->queries::INSERIR_PERIODO_TAXA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function deletarPeriodoTaxa($params){
        $sql = $this->queries::DELETAR_PERIODO_TAXA;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function verificaIntervalo($params){
        $sql = $this->queries::VERIFICA_INTERVALO;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function verificaIntervaloAlterar($params){
        $sql = $this->queries::VERIFICA_INTERVALO_ALTERAR;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    
   public function registerExists($params){
        $sql = $this->queries::REGISTER_EXISTS;
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}