<?php

namespace Teknisa\CNC\Services;

use Teknisa\CNC\Factories\Cnc02500SerieEstabelecimentoFactory;

class Cnc02500SerieEstabelecimentoService {
    protected $factory;

    public function __construct (Cnc02500SerieEstabelecimentoFactory $factory) {

        $this->factory = $factory;
        
    }
    
    public function getEstabelecSerie ($params) {
        
        $result = $this->factory->getEstabelecSerie(array(
            ":NRORG"        => $params["NRORG"],
            ":CDINSCESTA"   => $params["CDINSCESTA"],
            ":CDINSCMUNI"   => $params["CDINSCMUNI"],
            ":CDEMPRESA"    => $params["CDEMPRESA"]
            
        ));

        return $result;
    }
    
    public function save ($params){
        $paramsEst = $this->findEstabelecValid($params);
        $params["CDEMPRESA"]  = $paramsEst[0]["CDEMPRESA"];
        $params["CDINSCESTA"] = $paramsEst[0]["CDINSCESTA"];
        $params["CDINSCMUNI"] = $paramsEst[0]["CDINSCMUNI"];
        $seriesEstabelec = $this->getEstabelecSerie($params);
        $isEqual = false;
        foreach($seriesEstabelec as $serieEst) {
            if($serieEst["DSSERIE"] == $params["DSSERIE"]){
               $isEqual = true;
            }
        }
        if($isEqual){
            $result = $this->factory->save(array(
                ":CDSERIE"      => empty($params["CDSERIE"]) ? null : $params["CDSERIE"],
                ":CDEMPRESA"    => $params["CDEMPRESA"],
                ":CDINSCESTA"   => $params["CDINSCESTA"],
                ":CDINSCMUNI"   => $params["CDINSCMUNI"],
                ":NRESTABELEC"  => $params["NRESTABELEC"],
                ":NRORG"        => $params["NRORG"]
            ));
            return true;
        } else{
            return false;
        }
        
    }
    
    public function findEstabelecValid ($params){
        $result = $this->factory->findEstabelecValid(array(
            ":NRORG"        => $params["NRORG"],
            ":NRESTABELEC"  => $params["NRESTABELEC"]
        ));

        return $result;
    }
    
    public function findSerieCadCheck ($params){
        $result = $this->factory->findSerieCadCheck(array(
            ":NRORG"        => $params["NRORG"],
            ":NRESTABELEC"  => $params["NRESTABELEC"]["value"]
        ));

        return $result;
    }
    
    public function findEstabelecSelect ($params){
        $result = $this->factory->findEstabelecSelect(array(
            ":TALL_FIELDS"  => $params["TALL_FIELDS"],
            ":ALL_FIELDS"   => $params["ALL_FIELDS"],
            ":NRORG"        => $params["NRORG"],
            ":NRESTABELEC"  => $params["NRESTABELEC"],
            ":TNRESTABELEC" => $params["TNRESTABELEC"]
        ));

        return $result;
    }
    
}