<?php

namespace Teknisa\CNC\Services;

use Teknisa\Libs\Util\Environment;

use Teknisa\CNC\Factories\Cnc02900RecebimentoDataCreditoFactory;

class Cnc02900RecebimentoDataCreditoService {
    protected $entityManager;
    protected $environment;
    protected $recebimentoDataCreditoFactory;
    
    public function __construct (\Doctrine\ORM\EntityManager $entityManager,Environment $environment, Cnc02900RecebimentoDataCreditoFactory $recebimentoDataCreditoFactory) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->recebimentoDataCreditoFactory = $recebimentoDataCreditoFactory;
    }
    
    public function find($row) {
        $row['NRORG'] = $this->environment->getNrOrgTrab();
        
        return $this->recebimentoDataCreditoFactory->find($row);
    }
    
    public function getAgencias ($row) {
        $result = $this->recebimentoDataCreditoFactory->getAgencias(array(
            ':CDBANCO'  => $row[0]['value'],
            ':NRORG'    => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }
    
    public function getBancoMasks ($CDBANCO) {
        $result = $this->recebimentoDataCreditoFactory->getBancoMasks(array(
            ':CDBANCO'  => $CDBANCO
        ));
        
        return $result;
    }

    public function getBancos () {
        $result = $this->recebimentoDataCreditoFactory->getBancos(array(
            ':NRORG'  => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }
    
    public function getContas ($row) {
        $result = $this->recebimentoDataCreditoFactory->getContas(array(
            ':CDBANCO'      => $row[0]['value'],
            ':CDAGENCIA'    => $row[1]['value'],
            ':NRORG'        => $this->environment->getNrOrgTrab()
        ));
        
        return $result;
    }



}